use std::sync::Arc;

use tokio::sync::Mutex;
use uuid::Uuid;

mod protocol;
mod server;
mod plugin;
mod ser;
mod varint;
mod client;

pub type ArcMutex<T> = Arc<Mutex<T>>;
pub type JsonValue = serde_json::Value;

#[derive(Clone, Debug)]
pub struct Player {
	name: String,
	uuid: Uuid,
}

#[derive(Clone, Debug)]
pub struct ClientInfo {
	addr: String,
	port: u16,
	proto_version: i32,
	proto_name: &'static str,
}


#[tokio::main]
async fn main() {
	server::run_server().await.unwrap()
}
